#include "testlib.h"
#include <numeric>

using namespace std;

#define fori(n) for(int i = 0; i < n; ++i)
#define forj(n) for(int j = 0; j < n; ++j)
#define re return
#define vec vector
#define all(x) x.begin(), x.end()
#define ll long long

struct dsu {
    vector<int> v, cnt;
    void build(int n) { v.resize(n); cnt.resize(n); iota(all(v), 0); fill(all(cnt), 1); }
    dsu() {}
    dsu(int n) { build(n); }
    int get_par(int i) { if (v[i] != i)v[i] = get_par(v[i]); re v[i]; }
    bool check(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); re i1 == i2; }
    void merge(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); if (i1 == i2)re; if (cnt[i1] > cnt[i2])swap(i1, i2); cnt[i1] += cnt[i2]; v[i2] = i1; }
};

vec<pair<int, int>> gen_tree(int n) {
    vec<pair<int, int>> ans;

    fori(n - 1) {
        int was = i + 1;
        ans.push_back({ rnd.next(1, was), i + 2 });
    }

    vec<int> rd = rnd.distinct(n, 1, n);

    for (auto& i : ans) {
        i.first = rd[i.first - 1];
        i.second = rd[i.second - 1];
    }

    re ans;
}

vec<pair<int, int>> gen_graph(int n, int m) {
    vec<pair<int, int>> tv = gen_tree(n);
    m -= n - 1;

    map<pair<int, int>, bool> mp;
    fori(tv.size()) {
        mp[tv[i]] = 1;
    }

    fori(m) {
        int a = 1, b = 1;
        while (a == b || mp[{ a, b }] || mp[{ b, a }]) {
            a = rnd.next(1, n);
            b = rnd.next(1, n);
        }

        mp[{ a, b }] = 1;

        tv.push_back({ a, b });
    }

    re tv;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = has_opt("n") ? opt<int>("n") : (int)2e5;
    ll delta = has_opt("d") ? opt<ll>("d") : (ll)1e9;
    ll mx = has_opt("mx") ? opt<ll>("mx") : (ll)1e9;

    println(n);

    fori(n) {
        ll l = rnd.next(1ll, mx);
        ll r = rnd.next(l, min(l + delta, mx));
        println(l, r);
    }
}
