#include "testlib.h"

using namespace std;

int n;
vector<pair<int, int>> s;

int check(InStream &in) {
    int k = in.readInt(1, n, "k");
    vector<int> group;
    set<int> rep;

    for (int i = 0; i < k; i++) {
        int sz = in.readInt(1, n, format("size_%d", i + 1));
        group = in.readInts(sz, 1, n, format("segments_%d", i + 1));
        for (int &si : group) {
            si--;
            in.ensuref(rep.count(si) == 0, "segment %d repeats", si + 1);
            rep.insert(si);
        }

        sort(group.begin(), group.end(), [&](int i1, int i2) {
            return s[i1].first < s[i2].first;
        });
        for (int j = 1; j < group.size(); j++) {
            in.ensuref(s[group[j]].first > s[group[j - 1]].second, "group %d contains an intersection", i + 1);
        }
    }
    
    in.ensuref(rep.size() == n, "not matching segments count");
    return k;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    for (int i = 0; i < n; i++) {
        int l = inf.readInt(), r = inf.readInt();
        s.emplace_back(l, r);
    }

    int ja = check(ans), pa = check(ouf);
    if (ja < pa) quitf(_wa, "jury has better answer");
    if (ja > pa) quitf(_fail, "participant has better answer");

    quitf(_ok, "all checks passed");

}