/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct seg {
    int i;
    int l, r;

    bool operator<(seg const &rhs) const {
        return l < rhs.l;
    }
};

int main() {

    in(int, n)
    vector<seg> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i].l >> s[i].r;
        s[i].i = i;
    }
    sort(all(s));

    ordered_set<pair<int, int>> rs;
    vector<int> back(n);
    rs.insert({0, -1});
    for (seg const &c : s) {
        int before = rs.order_of_key({c.l, -1}) - 1;
        auto prev = rs.find_by_order(before);
        back[c.i] = prev->second;
        if (prev->second != -1) rs.erase(prev);
        rs.insert({c.r, c.i});
    }

    cout << rs.size() - 1 << '\n';
    for (auto [r, i] : rs) {
        if (i == -1) continue;
        vector<int> res;
        while (i != -1) {
            res.push_back(i);
            i = back[i];
        }
        reverse(all(res));
        cout << res.size() << '\n';
        for (int ri : res) cout << ri + 1 << ' ';
        cout << '\n';
    }

}