//
// Created by danii on 25.10.2023.
//
#include "testlib.h"

using namespace std;
const int MAX_N = int(1e5), MAX_A = int(1e9);
using pii = pair<int, int>;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAX_N, "n");

    vector<int> permutation (n);
    for (int i = 1; i <= n; i++) {
        permutation[i - 1] = i;
    }

    inf.readEoln();
    vector<int> a (n);
    vector<pii> a_srt (n);
    set<int> times;
    for (int i = 0; i < n; i++) {
        a_srt[i].first = inf.readInt(1, MAX_A, "a_i");
        a_srt[i].second = i + 1;
        times.insert(a_srt[i].first);
        if (i < n - 1) {
            inf.readSpace();
        }
    }
    ensuref(times.size() == n, "A contains equal elements");

    sort(a_srt.begin(), a_srt.end(), [](pii a, pii b) {
        return a.first < b.first;
    });

    for (int i = 0; i < n; i++) {
        a[i] = a_srt[i].second;
    }

    inf.readEoln();
    vector<int> b (n);
    for (int i = 0; i < n; i++) {
        b[i] = inf.readInt(1, n, "c_i");
        if (i < n - 1) {
            inf.readSpace();
        }
    }

    ensuref(is_permutation(b.begin(), b.end(), permutation.begin()),
            "C is not a permutation");

    int start_shuffle = -1, finish_shuffle = n;
    for (int i = 0; i < n; i++) {
        if (a[i] != b[i] && start_shuffle == -1) {
            start_shuffle = i;
        }
        if (a[i] == b[i] && start_shuffle != -1 && finish_shuffle == n) {
            finish_shuffle = i;
        }
    }

    cout << start_shuffle << ' ' << finish_shuffle << endl;
    if (start_shuffle != -1) {
        if (finish_shuffle - start_shuffle == 2) {
            ensuref(a[finish_shuffle - 1] == b[start_shuffle] && a[start_shuffle] == b[finish_shuffle - 1],
                    "C is not a valid permutation of A according to statement");
        } else if (a[start_shuffle] == b[finish_shuffle - 1]) {
            for (int i = start_shuffle + 1; i < finish_shuffle; i++) {
                ensuref(a[i] == b[i - 1], "C is not a valid permutation of A according to statement");
            }
        } else if (a[finish_shuffle - 1] == b[start_shuffle]) {
            for (int i = start_shuffle + 1; i < finish_shuffle; i++) {
                ensuref(b[i] == a[i - 1], "C is not a valid permutation of A according to statement");
            }
        } else {
            ensuref(false, "C is not a valid permutation of A according to statement");
        }
    }

    inf.readEoln();
    inf.readEof();
    return 0;
}