/*
    @author: EgorUlin
    Egor Ulin, ITMO University
*/
 
#include <iostream>
#include <cstring>
#include <algorithm>
#include <map>
#include <vector>
 
using namespace std;
 
#define re return
#define fori(n) for(int i = 0; i < n; ++i)
#define forj(n) for(int j = 0; j < n; ++j)
#define vec vector
 
void top_sort(int i, vec< vec<int> >& v, vec<int>& ts, vec<bool>& was) {
    if (was[i]) re;
    was[i] = 1;
 
    for (auto j : v[i]) {
        top_sort(j, v, ts, was);
    }
 
    ts.push_back(i);
}
 
void dfs(int i, vec< vec<int> >& v, vec<bool>& was, int nowComp, vec<int>& comp) {
    if (was[i]) re;
    was[i] = 1;
 
    comp[i] = nowComp;
    for (auto j : v[i]) {
        dfs(j, v, was, nowComp, comp);
    }
}
 
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    
    int n, m; cin >> n >> m;
    map<string, int> mp;
 
    int p = 0;
    fori(n) {
        string s; cin >> s;
        mp[s] = p++;
    }
 
    vec< vec<int> > v(n);
    vec< vec<int> > rv(n);
 
    fori(m) {
        string a, b; cin >> a >> b;
        v[mp[a]].push_back(mp[b]);
        rv[mp[b]].push_back(mp[a]);
    }
 
    vec<int> ts;
    vec<bool> was(n, 0);
    fori(n) {
        top_sort(i, v, ts, was);
    }
 
    reverse(ts.begin(), ts.end());
    fill(was.begin(), was.end(), 0);
 
    int nowComp = 0;
    vec<int> comp(n);
    fori(n) {
        if (!was[ts[i]]) {
            dfs(ts[i], rv, was, nowComp++, comp);
        }
    }
 
    vec<int> cnt(nowComp);
 
    fori(n) {
        forj(v[i].size()) {
            if (comp[i] != comp[v[i][j]]) cnt[comp[i]]++;
        }
    }
 
    cout << count(cnt.begin(), cnt.end(), 0);
}
