#include "testlib.h"
#include "task_limits.h"
#include <vector>

using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    const int w = opt<int>("w", W_MAX);
    const int h = opt<int>("h", H_MAX);
    const int s1 = opt<int>("s1", S1_MAX);
    const int s2 = opt<int>("s2", S2_MAX);
    const int s3 = opt<int>("s3", S3_MAX);
    const int blank = opt<int>("blank");
    const int shot = opt<int>("shot");
    ensure(blank + shot <= w * h);

    vector<pair<int, int>> points;
    vector<string> fld(h, string(w, '.'));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            points.emplace_back(i, j);
        }
    }
    shuffle(points.begin(), points.end());
    for (int i = 0; i < blank; i++) {
        fld[points[i].first][points[i].second] = 'o';
    }
    for (int i = blank; i < blank + shot; i++) {
        fld[points[i].first][points[i].second] = 'x';
    }
    cout << w << " " << h << "\n";
    for (auto &line : fld) {
        cout << line << "\n";
    }
    cout << s1 << " " << s2 << " " << s3 << "\n";
    return 0;
}
