//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

//  by https://codeforces.com/profile/Nyaan
//  example submission:
//  https://codeforces.com/contest/1603/submission/133688639
template <uint32_t mod>
struct LazyMontgomeryModInt {
  using mint = LazyMontgomeryModInt;
  using i32 = int32_t;
  using u32 = uint32_t;
  using u64 = uint64_t;
 
  static constexpr u32 get_r() {
    u32 ret = mod;
    for (i32 i = 0; i < 4; ++i) ret *= 2 - mod * ret;
    return ret;
  }
 
  static constexpr u32 r = get_r();
  static constexpr u32 n2 = -u64(mod) % mod;
  static_assert(r * mod == 1, "invalid, r * mod != 1");
  static_assert(mod < (1 << 30), "invalid, mod >= 2 ^ 30");
  static_assert((mod & 1) == 1, "invalid, mod % 2 == 0");
 
  u32 a;
 
  constexpr LazyMontgomeryModInt() : a(0) {}
  constexpr LazyMontgomeryModInt(const int64_t &b)
      : a(reduce(u64(b % mod + mod) * n2)){};
 
  static constexpr u32 reduce(const u64 &b) {
    return (b + u64(u32(b) * u32(-r)) * mod) >> 32;
  }
 
  constexpr mint &operator+=(const mint &b) {
    if (i32(a += b.a - 2 * mod) < 0) a += 2 * mod;
    return *this;
  }

  constexpr mint &operator++() {
    return *this += 1;
  }

  constexpr mint operator++(int) {
    auto ret = *this;
    *this += 1;
    return ret;
  }

  constexpr mint &operator-=(const mint &b) {
    if (i32(a -= b.a) < 0) a += 2 * mod;
    return *this;
  }

  constexpr mint &operator--() {
    return *this -= 1;
  }

  constexpr mint operator--(int) {
    auto ret = *this;
    *this -= 1;
    return ret;
  }
 
  constexpr mint &operator*=(const mint &b) {
    a = reduce(u64(a) * b.a);
    return *this;
  }
 
  constexpr mint &operator/=(const mint &b) {
    *this *= b.inv();
    return *this;
  }
 
  constexpr friend mint operator+(mint a, const mint &b) { return a += b; }
  constexpr friend mint operator-(mint a, const mint &b) { return a -= b; }
  constexpr friend mint operator*(mint a, const mint &b) { return a *= b; }
  constexpr friend mint operator/(mint a, const mint &b) { return a /= b; }
  constexpr friend bool operator==(mint const& a, const mint &b) {
    return (a.a >= mod ? a.a - mod : a.a) == (b.a >= mod ? b.a - mod : b.a);
  }
  constexpr friend bool operator!=(mint const& a, const mint &b) {
    return (a.a >= mod ? a.a - mod : a.a) != (b.a >= mod ? b.a - mod : b.a);
  }
  constexpr friend bool operator<(mint const& a, const mint &b) {
    return (a.a >= mod ? a.a - mod : a.a) < (b.a >= mod ? b.a - mod : b.a);
  }
  constexpr mint operator-() const { return mint() - mint(*this); }
 
  constexpr mint power(int64_t n) const {
    mint ret(1), mul(*this);
    if (n < 0) {
      n = -n;
      mul = mul.inv();
    }
    while (n > 0) {
      if (n & 1) ret *= mul;
      mul *= mul;
      n >>= 1;
    }
    return ret;
  }
  
  constexpr mint inv() const { return power(mod - 2); }
 
  friend ostream &operator<<(ostream &os, const mint &b) {
    return os << b.get();
  }
 
  friend istream &operator>>(istream &is, mint &b) {
    int64_t t;
    is >> t;
    b = LazyMontgomeryModInt<mod>(t);
    return (is);
  }
  
  constexpr u32 get() const {
    u32 ret = reduce(a);
    return ret >= mod ? ret - mod : ret;
  }

  constexpr explicit operator int() const {
    return int(get());
  }

  constexpr explicit operator bool() const {
    return bool(get());
  }
 
  static constexpr u32 get_mod() { return mod; }
};
 
template <typename T>
struct Binomial {
  vector<T> f, g, h;
  Binomial(int MAX = 0) : f(1, T(1)), g(1, T(1)), h(1, T(1)) {
    extend(MAX + 1);    
  }

  void extend(int m) {
    int n = f.size();

    if (n >= m) {
      return;
    }

    f.resize(m);
    g.resize(m);
    h.resize(m);
    for (int i = n; i < m; i++) f[i] = f[i - 1] * T(i);
    g[m - 1] = f[m - 1].inv();
    h[m - 1] = g[m - 1] * f[m - 2];
    for (int i = m - 2; i >= n; i--) {
      g[i] = g[i + 1] * T(i + 1);
      h[i] = g[i] * f[i - 1];
    } 
  }

  void extend() {
    extend(2 * f.size());
  }
 
  T fact(int i) {
    if (i < 0) return T(0);
    while (i >= (int)f.size()) extend();
    return f[i];
  }
 
  T ifact(int i) {
    if (i < 0) return T(0);
    while (i >= (int)g.size()) extend();
    return g[i];
  }
 
  T inv(int i) {
    if (i < 0) return -inv(-i);
    while (i >= (int)h.size()) extend();
    return h[i];
  }
 
  T C(int n, int r) {
    if (n < 0 || n < r || r < 0) return T(0);
    return fact(n) * ifact(n - r) * ifact(r);
  }
 
  inline T operator()(int n, int r) { return C(n, r); }
 
  template <typename I>
  T multinomial(const vector<I>& r) {
    static_assert(is_integral<I>::value == true);
    int n = 0;
    for (auto& x : r) {
      if(x < 0) return T(0);
      n += x;
    }
    T res = fact(n);
    for (auto& x : r) res *= ifact(x);
    return res;
  }
 
  template <typename I>
  T operator()(const vector<I>& r) {
    return multinomial(r);
  }
 
  T C_naive(int n, int r) {
    if (n < 0 || n < r || r < 0) return T(0);
    T ret = T(1);
    r = min(r, n - r);
    for (int i = 1; i <= r; ++i) ret *= inv(i) * (n--);
    return ret;
  }
 
  T A(int n, int r) {
    if (n < 0 || n < r || r < 0) return T(0);
    return fact(n) * ifact(n - r);
  }
 
  T CR(int n, int r) {
    if (n < 0 || r < 0) return T(0);
    return r == 0 ? 1 : C(n + r - 1, r);
  }
};
// int const MOD = 998244353;
int const MOD = int(1e9 + 7);
using mint = LazyMontgomeryModInt<MOD>;
Binomial<mint> C;

vector<mint> mkpow(mint base, int mx) {
  vector<mint> res(mx + 1);
  res[0] = 1;
  for (int i = 1; i <= mx; ++i) {
    res[i] = res[i - 1] * base;
  }
  return res;
}

string printMint(mint x, int mx = 100) {
  for (int p = -mx; p <= mx; ++p) {
    for (int q = 1; q <= mx; ++q) {
      if (mint(p) * C.inv(q) == x) {
        int pp = p;
        int qq = q;
        int g = gcd(pp, qq);
        pp /= g;
        qq /= g;
        return to_string(pp) + "/" + to_string(qq);
      }
    }
  }
  return "?";
}

int const N = 8;
int const ST = 4e5;

mint dp[2][1 << (2 * N)][6][5][4];
bool found[1 << (2 * N)][6][5][4];
tuple<int, int, int, int> states[2][ST];
int cntSt[2];

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int m, n;
  cin >> m >> n;
  vector<string> a(n);
  for (auto& s : a) {
    cin >> s;
  }
  int need1, need2, need3;
  cin >> need1 >> need2 >> need3;
  struct Trans {
    int newState;
    int newMask;
    array<int, 3> cnt;
  };
  vector<vector<Trans>> forState(1 << (2 * n));
  for (int fst = 0; fst < (1 << (2 * n)); ++fst) {
    vector<int> types(n);
    for (int i = 0; i < n; ++i) {
      types[i] = (fst >> (2 * i) & 3);
    }
    auto rec = [&](auto self, int i, int st, int msk, array<int, 3> cnt) -> void {
      if (i == n) {
        forState[fst].push_back({st, msk, cnt});
        return;
      }
      if (types[i] != 0) {
        //  continue ship
        self(self, i + 1, st | (types[i] - 1) << (2 * i), msk | ((types[i] > 1) << i), cnt);
        return;
      }
      self(self, i + 1, st, msk, cnt);
      if (i > 0 && types[i - 1] > 1) {
        return;
      }
      //  start horizontal ship
      if (i + 1 == n || types[i + 1] <= 1) {
        for (int len = 2; len <= 3; ++len) {
          auto ncnt = cnt;
          ncnt[len - 1] += 1;
          self(self, min(n, i + 2), st | (len << (2 * i)), msk | (1 << i), ncnt);
        }
      }
      //  start vertical ship
      int nsk = msk;
      int nst = st;
      for (int len = 1; len <= 3 && i + len <= n; ++len) {
        if (types[i + len - 1] != 0) {
          return;
        }
        nsk |= (1 << (i + len - 1));
        nst |= (1 << (2 * (i + len - 1)));
        if (i + len == n || types[i + len] <= 1) {
          auto ncnt = cnt;
          ncnt[len - 1] += 1;
          self(self, min(n, i + len + 1), nst, nsk, ncnt);
        }
      }
    };
    rec(rec, 0, 0, 0, array<int, 3>{});
  }
  debug("end precalc");
  int s = 0;
  int t = 1;
  dp[s][0][0][0][0] = 1;
    
  states[s][cntSt[s]++] = {0, 0, 0, 0};
  ll nstates = 0;
  ll okstates = 0;
  for (int i = 0; i < m; ++i, swap(s, t)) {
    memset(dp[t], 0, sizeof dp[t]);
    memset(found, 0, sizeof found);
    cntSt[t] = 0;
    int mustOne = 0;
    int mustZero = 0;
    for (int j = 0; j < n; ++j) {
      if (a[j][i] == 'o') {
        mustZero |= 1 << j;
      }
      if (a[j][i] == 'x') {
        mustOne |= 1 << j;
      }
    }

    for (int ptr = 0; ptr < cntSt[s]; ++ptr){
      auto[st, c1, c2, c3] = states[s][ptr];
      auto val = dp[s][st][c1][c2][c3];
      if (val == 0) {
        continue;
      }
      /*vector<int> types(n);
      for (int j = 0; j < n; ++j) {
        types[j] = (st >> (2 * j) & 3);
      }
      debug(i, types, c1, c2, c3, val);
      */
      for (auto& tr : forState[st]) {
        nstates += 1;
        int nc1 = c1 + tr.cnt[0];
        int nc2 = c2 + tr.cnt[1];
        int nc3 = c3 + tr.cnt[2];
        /*vector<int> ntypes(n);
        for (int j = 0; j < n; ++j) {
          ntypes[j] = (tr.newState >> (2 * j) & 3);
        }
        debug("go", ntypes, nc1, nc2, nc3);
        */
        if (nc1 > 5 || nc2 > 4 || nc3 > 3) {
          continue;
        }
        if (tr.newMask & mustZero) {
          continue;
        }
        if ((tr.newMask & mustOne) != mustOne) {
          continue;
        }
        okstates += 1;
        if (!found[tr.newState][nc1][nc2][nc3]) {
          found[tr.newState][nc1][nc2][nc3] = 1;
          states[t][cntSt[t]++] = {tr.newState, nc1, nc2, nc3};
        }
        dp[t][tr.newState][nc1][nc2][nc3] += val;
      }  
    }
  }
  debug(nstates, okstates);
  mint ans = 0;
  for (int x = 0; x < (1 << n); ++x) {
    int state = 0;
    for (int i = 0; i < n; ++i) {
      state += (x >> i & 1) << (2 * i);
    }
    ans += dp[s][state][need1][need2][need3];
  }
  cout << ans << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
