using namespace std;

#include <iostream>
#include <iomanip>
#include <vector>
#include <queue>
#include <unordered_set>
#include <algorithm>
#include <functional>
#include <cassert>
#include <cmath>

using ll = long long;

const ll MAX = LLONG_MAX;

struct SegTree {
    typedef int value_t;
    value_t neitral_v = 0;

    value_t sum_f(value_t a, value_t b) {
        return a + b;
    }

    SegTree(int n) : nn(pow(2, floor(log2(n - 1)) + 1)), ar(nn * 2, neitral_v) {
        for (int i = 0; i < n; ++i) {
            ar[nn - 1 + i] = 1;
        }
        for (int i = nn - 2; i >= 0; --i) {
            ar[i] = sum_f(ar[i * 2 + 1], ar[i * 2 + 2]);
        }
    }

    value_t ssum(int l, int r) {
        return ssum(l, r, 0, 0, nn);
    }

    value_t ssum(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return neitral_v;
        }
        if (l <= lx && rx <= r) {
            return ar[x];
        }
        int m = (lx + rx) / 2;
        return sum_f(ssum(l, r, x * 2 + 1, lx, m), ssum(l, r, x * 2 + 2, m, rx));
    }

    void sset(int l, int r, value_t v) {
        sset(l, r, 0, 0, nn, v);
    }

    void sset(int l, int r, int x, int lx, int rx, value_t v) {
        if (l <= lx && rx <= r) {
            ar[x] = v;
            return;
        }
        if (l >= rx || r <= lx) {
            return;
        }
        int m = (lx + rx) / 2;
        sset(l, r, x * 2 + 1, lx, m, v);
        sset(l, r, x * 2 + 2, m, rx, v);
        ar[x] = sum_f(ar[x * 2 + 1], ar[x * 2 + 2]);
    }

    int nn;
    vector<value_t> ar;
};

int main() {
    int n;

    cin >> n;
    if (n == 1) {
        cout << "1\n";
        return 0;
    }

    vector<int> a(n);
    vector<int> ain(n + 1);

    for (int i = n - 1; i >= 0; --i) {
        cin >> a[i];
        ain[a[i]] = i;
    }

    SegTree st(n);

    int cur_d = 0;
    ll ans = 0;

    for (int c = 1; c <= n; ++c) {
        int it = ain[c]; // c between element p1 and element p1 + 1
        int p1 = it;
        int p2 = it + 1;
        int a1 = st.ssum(min(cur_d, p1), max(cur_d, p1));
        int a2 = st.ssum(min(cur_d, p2), max(cur_d, p2));
        if (a1 < a2) {
            ans += a1;
            cur_d = p1;
        } else {
            ans += a2;
            cur_d = p2;
        }

        // x y ^ c ^ z w
        st.sset(it, it + 1, 0);
    }

    cout << ans + n << "\n";
}