#include <bits/stdc++.h>
using namespace std;

#define MULTITEST
/// #define LOCAL

struct MatchingDinic {

    vector<int>* g;
    int l;
    int r;
    vector<int> d;
    vector<int> ptr;
    vector<int> p;
    vector<int> in_m;

    MatchingDinic(int l = 0, int r = 0): l(l), r(r) {
        g = new vector<int>[l];
        d.resize(l);
        ptr.resize(l);
        p.resize(r, -1);
        in_m.resize(l, 0);
    }

    ~MatchingDinic() {
        delete[] g;
    }

    void add(int u, int v) {
        g[u].push_back(v);
    }

    bool bfs() {
        fill(d.begin(), d.end(), l + r);
        fill(ptr.begin(), ptr.end(), 0);
        deque<int> q;
        for (int i = 0; i < l; ++i) {
            if (!in_m[i]) {
                q.push_back(i);
                d[i] = 0;
            }
        }
        bool is_good = false;
        while (!q.empty()) {
            int v = q.front();
            q.pop_front();
            for (int u : g[v]) {
                if (p[u] == -1) {
                    is_good = true;
                    continue;
                }
                if (d[p[u]] > d[v] + 1) {
                    d[p[u]] = d[v] + 1;
                    q.push_back(p[u]);
                }
            }
        }
        return is_good;
    }

    bool dfs(int v) {
        for (; ptr[v] < (int)g[v].size(); ++ptr[v]) {
            int u = g[v][ptr[v]];
            if (p[u] == -1 || (d[p[u]] == d[v] + 1 && dfs(p[u]))) {
                p[u] = v;
                in_m[v] = true;
                return true;
            }
        }
        return false;
    }

    int find_match() {
        int ans = 0;
        while (bfs()) {
            for (int i = 0; i < l; ++i) {
                if (!in_m[i]) {
                    ans += dfs(i);
                }
            }
        }
        return ans;
    }

    vector<int> get_free() {
        bfs();
        vector<int> ans;
        for (int i = 0; i < l; ++i) {
            if (d[i] < l + r) {
                ans.push_back(i);
            }
        }
        return ans;
    }
};

const int MAXN = 1e5;
vector<int> dp[MAXN];
vector<int> g[MAXN];
vector<array<int, 2>> e[MAXN];

vector<int> ord;
int used[MAXN];

void build_ord(int v) {
    used[v] = true;
    int id = -1;
    for (int i = 0; i < (int)g[v].size(); ++i) {
        if (used[g[v][i]]) {
            id = i;
            continue;
        }
        build_ord(g[v][i]);
    }
    ord.push_back(v);
    if (id != -1) {
        swap(g[v][id], g[v][(int)g[v].size() - 1]);
        g[v].pop_back();
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        e[i].clear();
    }
    for (int i = 1; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        e[u].push_back({v, 2 * i - 2});
        e[v].push_back({u, 2 * i - 1});
    }
    for (int i = 0; i < n; ++i) {
        dp[i].clear();
        dp[i].resize(2 * m, 0);
    }

    ord.clear();
    fill(used, used + n, 0);
    build_ord(0);

    for (int v : ord) {
        for (int u = 0; u < m; ++u) {
            int lft = e[u].size(), rgh = g[v].size();
            if (rgh < lft - 1) {
                continue;
            }
            MatchingDinic match(lft, rgh);
            for (int i = 0; i < rgh; ++i) {
                for (int j = 0; j < lft; ++j) {
                    if (dp[g[v][i]][e[u][j][1]]) {
                        match.add(j, i);
                    }
                }
            }
            int val = match.find_match();
            if (val == lft) {
                cout << "YES\n";
                return;
            } else if (val < lft - 1) {
                continue;
            }
            auto arr = match.get_free();
            for (int j : arr) {
                dp[v][e[u][j][1] ^ 1] = 1;
            }
        }
    }
    cout << "NO\n";
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int tst = 1;
#ifdef MULTITEST
    cin >> tst;
#endif // MULTITEST
    while (tst--) {
        solve();
#ifdef LOCAL
        cout.flush();
#endif // LOCAL
    }
    return 0;
}
