#include <bits/stdc++.h>
using namespace std;

#define MULTITEST
#define LOCAL

struct MatchingKuhn {
    vector<int>* g;
    vector<int> p;
    vector<int> used;
    vector<int> in_m;
    int tm;
    int n;

    MatchingKuhn(int n = 0, int m = 0): tm(0), n(n) {
        g = new vector<int>[n];
        p.resize(m, -1);
        used.resize(n, 0);
        in_m.resize(n, 0);
    }

    void add(int u, int v) {
        g[u].push_back(v);
    }

    bool dfs(int v) {
        used[v] = tm;
        for (int u : g[v]) {
            if (p[u] == -1 || (used[p[u]] != tm && dfs(p[u]))) {
                p[u] = v;
                in_m[v] = 1;
                return true;
            }
        }
        return false;
    }

    int find_match() {
        int ans = 0;
        bool found = true;
        while (found) {
            ++tm;
            found = false;
            for (int i = 0; i < n; ++i) {
                if (!in_m[i] && used[i] != tm) {
                    if (dfs(i)) {
                        found = true;
                        ++ans;
                    }
                }
            }
        }
        return ans;
    }

    vector<int> get_free() {
        for (int i = 0; i < n; ++i) {
            if (!in_m[i]) {
                ++tm;
                dfs(i);
                break;
            }
        }
        vector<int> ans;
        for (int i = 0; i < n; ++i) {
            if (used[i] == tm) {
                ans.push_back(i);
            }
        }
        return ans;
    }
};

vector<vector<int>> dp;
const int MAXN = 1e5;
vector<int> g[MAXN];
vector<array<int, 2>> e[MAXN];

vector<int> ord;
int used[MAXN];

void build_ord(int v) {
    used[v] = true;
    int id = -1;
    for (int i = 0; i < (int)g[v].size(); ++i) {
        if (used[g[v][i]]) {
            id = i;
            continue;
        }
        build_ord(g[v][i]);
    }
    ord.push_back(v);
    if (id != -1) {
        swap(g[v][id], g[v][(int)g[v].size() - 1]);
        g[v].pop_back();
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        e[i].clear();
    }
    for (int i = 1; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        e[u].push_back({v, 2 * i - 2});
        e[v].push_back({u, 2 * i - 1});
    }
    dp.clear();
    dp.resize(n, vector<int>(2 * m, 0));

    ord.clear();
    fill(used, used + n, 0);
    build_ord(0);

    for (int v : ord) {
        for (int u = 0; u < m; ++u) {
            int lft = e[u].size(), rgh = g[v].size();
            if (rgh < lft - 1) {
                continue;
            }
            MatchingKuhn match(lft, rgh);
            for (int i = 0; i < rgh; ++i) {
                for (int j = 0; j < lft; ++j) {
                    if (dp[g[v][i]][e[u][j][1]]) {
                        match.add(j, i);
                    }
                }
            }
            int val = match.find_match();
            if (val == lft) {
                cout << "YES\n";
                return;
            } else if (val < lft - 1) {
                continue;
            }
            auto arr = match.get_free();
            for (int j : arr) {
                dp[v][e[u][j][1] ^ 1] = 1;
            }
        }
    }
    cout << "NO\n";
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int tst = 1;
#ifdef MULTITEST
    cin >> tst;
#endif // MULTITEST
    while (tst--) {
        solve();
#ifdef LOCAL
        cout.flush();
#endif // LOCAL
    }
    return 0;
}
