#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld long double
#define all(a) (a).begin(), (a).end()

const int total_N = 200000 + 5;
const int N = 200000 + 5;
const int M = 20000 + 5;

// kun
vector<int> go[N];
int match[N];
int used[M];
int used_top = 0;

int edjes_count = 0;

void clear_kun(int l, int r) {
    for (int i = 0; i < l; ++i) go[i].clear();
    for (int i = 0; i < r; ++i) match[i] = -1;
}

bool dfs1(int u) {
    for (int i : go[u]) {
        if (match[i] == -1) {
            match[i] = u;
            return true;
        }
    }
    used[u] = used_top;
    for (int i : go[u]) {
        if ((used[match[i]] != used_top) && dfs1(match[i])) {
            // with[u] = i;
            match[i] = u;
            return true;
        }
    }
    return false;
}

void dfs2(int u, vector<char>& reached) {
    reached[u] = true;
    for (int i : go[u]) {
        if (!reached[match[i]]) dfs2(match[i], reached);
    }
}

// true if exists perfect, true in without if exists all but this one
bool kun(vector<char>& without) {
    int unable = -1;
    for (int i = 0; i < without.size(); ++i) {
        // if (!dfs1(i)) {
        used_top++;
        if (!dfs1(i)) {
            if (unable != -1) return false;
            unable = i;
        }
        // }
    }

    if (unable == -1) return true;
    dfs2(unable, without);
    return false;
}

// kun

vector<int> gn[N];
vector<int> gm[M];

vector<pii> medjes;
vector<int> mind[M];
vector<int> anti;

vector<char> dp[N];

int n, m;
bool get_res(int u, int p) {
    dp[u].assign(2 * m - 2, false);

    for (int i = 0; i < gn[u].size(); ++i) {
        if (gn[u][i] == p) {
            gn[u].erase(gn[u].begin() + i);
            --i;
            continue;
        }
        if (get_res(gn[u][i], u)) return true;
    }

    for (int j = 0; j < m; ++j) {
        if (gn[u].size() + (p != -1) < gm[j].size()) continue;
        for (int i = (p != -1); i < gm[j].size(); ++i) {
            if (gn[gn[u][i - (p != -1)]].size() < gm[gm[j][i]].size()) continue;
        }

        int count_no_edjes = 0;

        clear_kun(gm[j].size(), gn[u].size());
        for (int k = 0; k < gm[j].size(); ++k) {
            // matching edje u->gn[u][i] with j->gm[j][k]
            // so need dp[gn[u][i]][gm[j][k]->j] 
            bool some = false;
            for (int i = 0; i < gn[u].size(); ++i) {
                if (dp[gn[u][i]][anti[mind[j][k]]]) {
                    go[k].push_back(i);
                    edjes_count++;
                    some = true;
                }
            }
            if (!some) count_no_edjes++;
            if (count_no_edjes == 2) break;
        }
        if (count_no_edjes == 2) continue;

        vector<char> tmp(gm[j].size(), false);
        if (kun(tmp)) {
            // cerr << "matched " << u + 1 << " and " << j + 1 << '\n';
            return true;
        } else {
            for (int k = 0; k < gm[j].size(); ++k) {
                dp[u][mind[j][k]] = tmp[k];
            }
        }
    }

    return false;
}

void input() {
    cin >> n;
    
    for (int i = 0; i < n; ++i) gn[i].clear();

    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        gn[u].push_back(v);
        gn[v].push_back(u);
    }
    
    cin >> m;

    for (int i = 0; i < m; ++i) gm[i].clear();

    for (int i = 0; i < m - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        gm[u].push_back(v);
        gm[v].push_back(u);
    }
}

void solve() {
    input();


    if (n < m) {
        cout << "No\n";
        return;
    }

    for (int i = 0; i < n; ++i) {
        sort(all(gn[i]), [](int lhs, int rhs){
            return gn[lhs].size() > gn[rhs].size();
        });
    }
    for (int i = 0; i < m; ++i) {
        sort(all(gm[i]), [](int lhs, int rhs){
            return gm[lhs].size() > gm[rhs].size();
        });
    }

    medjes.clear();
    map<pii, int> pos;
    for (int j = 0; j < m; ++j) {
        mind[j].clear();
        for (int k : gm[j]) {
            pos[{j, k}] = medjes.size();
            mind[j].push_back(medjes.size());
            medjes.push_back({j, k});
        }
    }

    anti.resize(2 * m - 2);
    for (int j = 0; j < m; ++j) {
        for (int k : gm[j]) {
            anti[pos[{j, k}]] = pos[{k, j}];
        }
    }

    bool res = get_res(0, -1);
    cout << (res ? "Yes" : "No") << '\n';

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

    cerr << "total edjes in kun = " << edjes_count << '\n';

    return 0;
}
