#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>

using namespace std;

const int inf = 1e9;

vector<int> pi(string &s) {
    int n = (int)s.size();
    vector<int> pref(n);
    int j;
    for (int i = 1; i < n; i++) {
        j = pref[i - 1];
        while (j > 0 && s[i] != s[j]) j = pref[j - 1];
        if (s[i] == s[j]) j++;
        pref[i] = j;
    }
    return pref;
}

bool contains(string &s1, string &s2) {
    int x = (int) s1.size(), y = (int) s2.size();
    if (x > y) return false;
    string s = s1 + '#' + s2;
    vector<int> p = pi(s);
    for (int i = x + 1; i <= x + y; i++) {
        if (p[i] == x) return true;
    }
    return false;
}

int getCommon(string &s1, string &s2) {
    string s = s2 + '#' + s1;
    return pi(s).back();
}

void solve() {
    int n;
    cin >> n;
    vector<string> a(n);
    for (auto &i : a) cin >> i;
    bool ok = true;
    while (ok) {
        ok = false;
        for (int i = n - 1; i >= 0; i--) {
            for (int j = 0; j < n; j++) {
                if (i != j && contains(a[i], a[j])) {
                    a.erase(a.begin() + i);
                    n--;
                    ok = true;
                    break;
                }
            }
            if (ok) break;
        }
    }
    int d[n][n];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j) d[i][j] = a[j].length() - getCommon(a[i], a[j]);
            else d[i][j] = 0;
        }
    }

    int dp[n][1 << n];
    for (int i = 0; i < n; i++) for (int mask = 0; mask < (1 << n); mask++) dp[i][mask] = inf;
    for (int i = 0; i < n; i++) dp[i][1 << i] = a[i].size();
    for (int mask = 0; mask < (1 << n); mask++) {
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                for (int j = 0; j < n; j++) {
                    if (mask & (1 << j)) {
                        dp[i][mask] = min(dp[i][mask], dp[j][mask ^ (1 << i)] + d[j][i]);
                    }
                }
            }
        }
    }

    vector<int> path(1);
    int res = inf;
    for (int i = 0; i < n; i++) {
        if (dp[i][(1 << n) - 1] < res) {
            res = dp[i][(1 << n) - 1];
            path[0] = i;
        }
    }
    int mask = (1 << n) - 1;
    while (path.size() < n) {
        int cur;
        int i = path.back();
        for (int j = 0; j < n; j++) {
            if ((mask & (1 << j)) && dp[i][mask] == dp[j][mask ^ (1 << i)] + d[j][i]) {
                cur = j;
            }
        }
        mask ^= (1 << i);
        path.push_back(cur);
    }
    reverse(path.begin(), path.end());
    string result = a[path[0]];
    for (int i = 1; i < n; i++) {
        int j = path[i];
        result += a[j].substr(a[j].size() - d[path[i - 1]][j]);
    }
    cout << result << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests;
    cin >> tests;
    while (tests--) solve();
}