/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

struct point {
    int x, y;
    ll p;
};

int const XM = 1000'000;

int main() {

    in(int, n)
    vector<point> pts(n);
    ll pt = 0;
    for (int i = 0; i < n; i++) {
        cin >> pts[i].p;
        pt += pts[i].p;
    }
    for (int i = 0; i < n; i++) {
        in(int, x, y)
        pts[i].x = x - y;
        pts[i].y = x + y;
    }

    auto locate = [&]() {
        ll half = 0;
        for (int i = 0; i < n; i++) {
            half += pts[i].p;
            if (pt <= 2 * half) {
                return i;
            }
        }
    };
    sort(all(pts), [](point const &p1, point const &p2) {
        return p1.x < p2.x;
    });
    int rx = pts[locate()].x;
    sort(all(pts), [](point const &p1, point const &p2) {
        return p1.y < p2.y;
    });
    int ry = pts[locate()].y;
    cout << (rx + ry) << ' ' << (ry - rx) << '\n';

}