/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

struct point {
    int x, y;
    ll p;
};

int const XM = 1000'000;

int main() {

    in(int, n)
    vector<point> pts(n);
    for (int i = 0; i < n; i++) {
        cin >> pts[i].p;
    }
    int minx = XM, miny = XM, maxx = -XM, maxy = -XM;
    for (int i = 0; i < n; i++) {
        cin >> pts[i].x >> pts[i].y;
        minx = min(minx, pts[i].x);
        maxx = max(maxx, pts[i].x);
        miny = min(miny, pts[i].y);
        maxy = max(maxy, pts[i].y);
    }

    int rx = 0, ry = 0;
    ll res = LLONG_MAX;
    for (int x = minx; x <= maxx; x++) {
        for (int y = miny; y <= maxy; y++) {
            ll total = 0;
            for (int i = 0; i < n; i++) {
                total += pts[i].p * max(abs(x - pts[i].x), abs(y - pts[i].y));
            }
            if (total < res) {
                res = total;
                rx = x;
                ry = y;
            }
        }
    }
    cout << 2 * rx << ' ' << 2 * ry << '\n';

}